define(["dojo/_base/declare","dojo/on","dojo/mouse","dojo/when","dojo/dom-construct","dojo/dom-style","dojo/dom-class","dojo/Deferred","dijit/_WidgetBase","dijit/_TemplatedMixin","dijit/_WidgetsInTemplateMixin","epi/shell/dnd/Target","epi/shell/widget/dialog/Alert","epi/shell/DialogService","adaptiveimages/_LogMixin","adaptiveimages/AdaptiveImagesStore","adaptiveimages/helpers/FilesizeValidator","adaptiveimages/helpers/ContentHelper","adaptiveimages/widget/dialog/CropDialog","dojo/i18n!./nls/Labels","dojo/text!./AdaptiveImageDetailsEditor.html","xstyle/css!./AdaptiveImageDetailsEditor.css"],function(i,t,e,o,n,s,r,a,h,d,l,m,p,g,u,c,f,v,z,b,w){return i([h,d,l,u],{debugLogName:"AdaptiveImageDetailsEditor",templateString:w,name:null,displayName:null,imageId:null,localized:b,proportions:null,loader:null,readOnly:!1,minimumSize:{width:0,height:0},provider:null,filename:null,left:null,right:null,top:null,bottom:null,width:null,height:null,alternateText:null,_store:null,constructor:function(){this.inherited(arguments),this._store=new c},_setImageIdAttr:function(i){this._set("imageId",i),this._setThumbnail()},_setProviderAttr:function(i){if(null!==i&&"string"!=typeof i)throw"Adaptive image provider name must be a string or null";this._set("provider",i)},_openCropDialog:function(i){var t;this.imageId&&(this.own(t=new z({title:`${b.dialogs.crop} ${this.displayName?this.displayName.toLowerCase():""}`.trim(),provider:this.provider,imageId:this.imageId,filename:this.filename,proportions:this.proportions,minimumSize:this.minimumSize,model:{left:this.get("left"),right:this.get("right"),top:this.get("top"),bottom:this.get("bottom")},onOkAction:function(i){["left","right","top","bottom"].forEach(function(t){this.set(t,i[t])}.bind(this)),this.imageCropped(i,this.name)}.bind(this)})),t.show())},_target:null,postCreate:function(){this.inherited(arguments)},startup:function(){this.inherited(arguments),this.readOnly?r.add(this.editorContainer,"dijitReadOnly"):(this._target=new m(this.dropzone,{accept:["adaptiveimage","link"],createItemOnDrop:!1}),t(this._target,"DropData",this._onDrop.bind(this)),t(this.cropOption,"click",this._openCropDialog.bind(this)),t(this.thumbnailImage,"click",this._openCropDialog.bind(this)),t(this.resetCropOption,"click",function(){return o(g.confirmation({title:b.dialogs.resetCrop.title,description:b.dialogs.resetCrop.description}),function(){this.log("Resetting crop settings..."),["left","right","top","bottom"].forEach(function(i){this.set(i,null)}.bind(this)),this.imageCropped(null,this.name)}.bind(this),function(i){})}.bind(this)),t(this.dropzone,e.enter,function(){this._setCropResetButtonVisibility()}.bind(this)))},imageDropped:function(i,t,e){},imageCropped:function(i,t){},hasSizeConstraint:function(){return this.minimumSize&&(this.minimumSize.width>0||this.minimumSize.height>0)},hasProportionsConstraint:function(){return this.proportions&&this.proportions.x>0&&this.proportions.y>0},validateImageSizeAndProportions:function(i,t){this.log(`Validating image of ${i}x${t} pixels for form factor '${this.name}'...`);var e={name:this.name,displayName:this.displayName,imageSize:i&&t?{width:i,height:t}:null,validSize:!0,validProportions:!0,sizeConstraint:this.minimumSize,proportionsConstraint:this.proportions},o=this.hasSizeConstraint(),n=this.hasSizeConstraint();if(o&&((e.imageSize.width<this.minimumSize.width||e.imageSize.height<this.minimumSize.height)&&(this.logWarn(`Image for '${this.name}' does not fulfill size restriction: width >= ${this.minimumSize.width}, height >= ${this.minimumSize.height}`),e.validSize=!1),n)){var s=parseInt(this.minimumSize.width/(this.proportions.x/this.proportions.y));e.imageSize.height<s&&(this.logWarn(`Height of ${e.imageSize.height} does not meet minimum proportionate height of ${s}`),e.sizeConstraint.height=Math.max(s,e.sizeConstraint.height),e.validProportions=!1);var r=parseInt(this.minimumSize.height*(this.proportions.x/this.proportions.y));e.imageSize.width<r&&(this.logWarn(`Width of ${e.imageSize.width} does not meet minimum proportionate width of ${r}`),e.sizeConstraint.width=Math.max(r,e.sizeConstraint.width),e.validProportions=!1)}return e},validateImageSizeAndProportionsOfExternalImage:function(i,t){this.log(`Validating image with ID '${t}' from provider '${i}'...`);var e=new a(function(i){this.log("Image size check cancelled",i)}.bind(this)),o=this.hasSizeConstraint(),n=this.hasSizeConstraint();if(o||n)this._store.getMetaData(i,t).then(function(i){var t=this.validateImageSizeAndProportions(i.width,i.height);e.resolve(t)}.bind(this));else{var s=this.validateImageSizeAndProportions();e.resolve(s)}return e},_onDrop:function(i,t,e,n){var s=i?i.length?i[0]:i:null;s&&o(s.data,function(i){s.type.includes("adaptiveimage")&&i.imageId?this._handleExternalAdaptiveImageDrop(i):s.type.includes("link")?this._handleEpiserverImageDrop(i):this.logWarn("Unexpected drop",s)}.bind(this))},_isValidFilesize:function(){const i=new f;var t=new a;return o(i.isValidFilesize.apply(this,arguments),function(i){i||new p({heading:b.dialogs.exceedingFilesize.title,description:b.dialogs.exceedingFilesize.description}).show(),t.resolve(i)}.bind(this)),t},_handleExternalAdaptiveImageDrop:function(i){this.log("Adaptive image dropped",i),o(this._isValidFilesize(i.provider,i.imageId),function(t){t&&this.validateImageSizeAndProportionsOfExternalImage(i.provider,i.imageId).then(function(t){this.log("Validated image size and proportions",t),this._displayAlertIfDimensionsAreInvalid(t)||(this._set("imageId",i.imageId),this._set("filename",i.name),this._set("provider",i.provider),this._set("width",i.width),this._set("height",i.height),["left","right","top","bottom"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped(i.provider,i.imageId,this.name))}.bind(this))}.bind(this))},_handleEpiserverImageDrop:function(i){o(v.getContentFromUrl(i.permanentUrl),function(i){this.log("Episerver image dropped",i),o(this._isValidFilesize("episerver",i.contentGuid),function(t){t&&o(v.getRemoteImageDimensions(i.downloadUrl),function(t){this.log(`Dropped image is ${t.width}x${t.height} pixels`);var e=this.validateImageSizeAndProportions(t.width,t.height);this.log("Validated image size and proportions",e),this._displayAlertIfDimensionsAreInvalid(e)||(this._set("imageId",i.contentGuid),this._set("filename",v.getFilenameFromUrl(i.publicUrl)),this._set("provider","episerver"),this._set("width",t.width),this._set("height",t.height),["left","right","top","bottom"].forEach(function(i){this._set(i,null)}.bind(this)),this.imageDropped("episerver",i.contentGuid,this.name))}.bind(this))}.bind(this))}.bind(this))},_displayAlertIfDimensionsAreInvalid:function(i){var t;return i.validSize?!i.validProportions&&(new p({heading:b.dialogs.wrongProportions.title,description:b.dialogs.wrongProportions.description.replace("{x}",`${this.proportions.x}`).replace("{y}",`${this.proportions.y}`)}).show(),!0):(this.minimumSize.width>0&&this.minimumSize.height>0?t=b.dialogs.imageTooSmall.description.size.replace("{size}",`${this.minimumSize.width}x${this.minimumSize.height}`):this.minimumSize.width>0?t=b.dialogs.imageTooSmall.description.width.replace("{width}",`${this.minimumSize.width}`):this.minimumSize.height>0&&(t=b.dialogs.imageTooSmall.description.height.replace("{height}",`${this.minimumSize.height}`)),new p({heading:b.dialogs.imageTooSmall.title,description:t}).show(),!0)},_setThumbnail:function(){var i={id:this.get("imageId"),provider:this.get("provider"),name:this.get("filename"),originalWidth:this.get("width"),originalHeight:this.get("height")};if(i.id&&i.provider){var e={width:Math.round((1-this.get("left")-this.get("right"))*i.originalWidth),height:Math.round((1-this.get("bottom")-this.get("top"))*i.originalHeight),top:Math.round(this.get("top")*i.originalHeight),left:Math.round(this.get("left")*i.originalWidth)},o=this.proportions&&this.proportions.x>0&&this.proportions.y>0,a=this._hasCropSettings();this.log(`Updating ${a?"cropped ":""}${this.name?`${this.name} `:""}thumbnail${!a&&o?" cropped to proportions constraints":""}...`,{data:i,coordinates:e,proportionsConstraint:o?this.proportions:null,isCropped:a}),this._store.getThumbnailUrl(i.provider,i.id,i.name,Math.round(e.top),Math.round(e.left),Math.round(e.height+e.top),Math.round(e.width+e.left),!a&&o?this.proportions:null).then(function(i){this.thumbnailImage.src&&this.thumbnailImage.src.endsWith(i.url)?this.log(`Thumbnail already set for '${this.name}', no need to refresh...`,this.thumbnailImage):(this.log(`Loading thumbnail for ${this.displayName}: ${i.url}...`,this.thumbnailImage.src),this.loader.show());const e=n.toDom(`<img src="${i.url}" style="display:none" />`);t(e,"load",function(t){this.thumbnailImage.setAttribute("src",i.url),r.add(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),this.loader.hide(),s.set(this.thumbnailImage,{display:"inherit"}),n.destroy(e)}.bind(this)),t(e,"error",function(i){const t=i.path[0].currentSrc;this.logError("Unable to load thumbnail",t),this.loader.hide(),g.alertWithErrors({heading:b.dialogs.imageLoadError.title},[t])}.bind(this))}.bind(this)),r.remove(this.cropOption,"dijitReadOnly")}else s.set(this.thumbnailImage,{display:"none"}),r.remove(this.dropzone,"adaptiveimages-details-editor__dropzone--hasThumbnail"),r.add(this.cropOption,"dijitReadOnly"),this.loader.hide()},_setCropResetButtonVisibility:function(){this._hasCropSettings()?s.set(this.resetCropOption,"display","inherit"):s.set(this.resetCropOption,"display","none")},_hasCropSettings:function(){return this.get("right")>0||this.get("bottom")>0}})});